-------------------------------------------
--- AddOn: ReadySetDing					---
--- Author: Ketho (EU-Boulderfist)		---
--- License: Public Domain				---
-------------------------------------------
--- ReadySetDing	v0.80 [2011.02.17]	---
--- Ace3 Framework	r1009 [2011.02.09]	---
-------------------------------------------
--- AddOn: Curse			http://wow.curse.com/downloads/wow-addons/details/readysetding.aspx
--- AddOn: WoWInterface		http://www.wowinterface.com/downloads/info16220-ReadySetDing.html
--- I don't have any previous programming experience or background in any (scripting) language

-- http://www.wowace.com/addons/ace3/pages/api/ace-addon-3-0/
ReadySetDing = LibStub("AceAddon-3.0"):NewAddon("ReadySetDing", "AceEvent-3.0", "AceTimer-3.0", "AceConsole-3.0")
local RSD = ReadySetDing
local ACR = LibStub("AceConfigRegistry-3.0")
local ACD = LibStub("AceConfigDialog-3.0")

-- http://www.wowace.com/addons/ace3/pages/api/ace-locale-3-0/
local L = LibStub("AceLocale-3.0"):GetLocale("ReadySetDingLocale", true)

	--------------------
	--- 01  UPVALUES ---
	--------------------

local _G = _G -- global table

--# Lua APIs
-- http://www.wowpedia.org/Lua_functions
-- http://www.lua.org/manual/5.1/
local print = print
local pairs, select = pairs, select
local tonumber, unpack = tonumber, unpack
local floor, mod, random = floor, mod, random  -- math.floor,  math.fmod, math.random
local date, time = date, time -- os.date, os.time (mirrored)
local format, gsub = format, gsub -- string.format, string.gsub
local strfind, strlen, strsub = strfind, strlen, strsub -- string.find, string.len, string.sub
local strjoin, strtrim = strjoin, strtrim -- string.join, string.trim (WoW Lua)
local sort = sort -- table.sort
local band = bit.band -- BitLib library

--# WoW APIs
-- http://www.wowpedia.org/World_of_Warcraft_API
-- http://wowprogramming.com/docs/api
local SCM = SendChatMessage
local GS = GetStatistic
local PSF = PlaySoundFile
local UnitName = UnitName
local IsInGuild, GuildRoster, GetGuildRosterInfo = IsInGuild, GuildRoster, GetGuildRosterInfo
local IsInInstance, GetRealZoneText = IsInInstance, GetRealZoneText
local SetFormattedText = SetFormattedText

--# File-local scope variables
local profile, realm, char, stats
local TPM_currentLevelTime2, levelTime, levelTime2, timeInstanceStart, timeInstanceStart2, timeInstanceEnd, timeAFK1, timeAFK2
local randomIcon1, randomIcon2, soundPath, realZone, gratzName, playerDinged, showedDiffs, instanceType, levelSummaryString

-- http://wowprogramming.com/utils/xmlbrowser/live/FrameXML/GlobalStrings.lua
local DEFAULT = DEFAULT

-- http://wowprogramming.com/utils/xmlbrowser/live/FrameXML/Constants.lua
local RAID_CLASS_COLORS = RAID_CLASS_COLORS

-- I don't want the capitalized GlobalStrings (except for German locale)
local D_SECONDS = strlower(D_SECONDS)
local D_MINUTES = strlower(D_MINUTES)
local D_HOURS = strlower(D_HOURS)
local D_DAYS = strlower(D_DAYS)

if GetLocale() == "deDE" then
	D_SECONDS = _G.D_SECONDS
	D_MINUTES = _G.D_MINUTES
	D_HOURS = _G.D_HOURS
	D_DAYS = _G.D_DAYS
end

local bttn = CreateFrame("Button")
local D_MINUTES2 = gsub(D_MINUTES, "%%d", "%%.1f") -- replace decimal integer with float
local Hour = strreplace(bttn:GetText(bttn:SetFormattedText(_G.D_HOURS, 1)), "1 ", "") -- singular hour

-- http://www.wowpedia.org/UI_escape_sequences
local iconCropped = ":64:64:4:60:4:60"
local Main = "ReadySet|cffFFFFFFDing|r  |TInterface\\AddOns\\ReadySetDing\\Images\\Windows7_Logo:22:22:-4:0|t"

-- this string is so damned long it f*cks up my text editor (Notepad++)
local z1 = "\n|cff58ACFA[QUESTS]|r |cffFFFFFF= "..QUESTS_LABEL.."|r\n|cff58ACFA[ZONE]|r |cffFFFFFF= "..strupper(strsub(SPELL_TARGET_TYPE6_DESC, 1, 1))..strsub(SPELL_TARGET_TYPE6_DESC, 2).."|r\n|cffF6ADC6[LEVEL-]|r |cffFFFFFF= "..L["Previous Level"].."|r\n|cffF6ADC6[LEVEL]|r |cffFFFFFF= "..L["New Level"].."|r"
local z2 = "\n|cffF6ADC6[REM]|r |cffFFFFFF= "..L["Remaining Levels"].."|r\n|cffF6ADC6[MAX]|r |cffFFFFFF= "..L["Max Level"].."|r\n|cff71D5FF[TIME]|r |cffFFFFFF= "..L["Level Time"].."|r\n|cff71D5FF[TOTAL]|r |cffFFFFFF= "..L["Total Time"].."|r\n|cff71D5FF[DIFF]|r |cffFFFFFF= "..L["Time Difference"].."|r"
local z3 = "\n|cff71D5FF[AFK]|r, |cff71D5FF[AFK+]|r |cffFFFFFF= "..L["AFK Time"].."|r\n|cffB6CA00[SPEED]|r |cffFFFFFF= "..L["LevelSpeed"].."|r\n|cffB6CA00[SPEED+]|r |cffFFFFFF= "..L["Average LevelSpeed"].."|r\n|cff0070DD[DATE]|r  |cffFFFFFF= MM/DD/YY hh:mm|r\n|cff0070DD[DATE2]|r |cffFFFFFF= YYYY.MM.DD hh:mm|r"
local z4 = "\n|cffFF0000[KILLS]|r, |cffFF0000[KILLS+]|r |cffFFFFFF= "..L["Kills"].."|r\n|cffFF0000[DEATHS]|r, |cffFF0000[DEATHS+]|r |cffFFFFFF= "..L["Deaths"].."|r\n|cffADFF2F[NAME]|r, |cffADFF2F[CLASS]|r, |cffADFF2F[RACE]|r, |cffADFF2F[GUILD]|r, |cffADFF2F[FACTION]|r, |cffADFF2F[REALM]|r\n"..TARGETICONS..": |cffFFFFFF{Moon} |TInterface\\TargetingFrame\\UI-RaidTargetingIcon_5:12|t|r"
local legend = z1..z2..z3..z4


local lastPlayedRequest, timeLogin = time(), time()
local TPM_currentLevelTime, TPM_totalTime, TPM_totalTime2 = 0, 0, 0
local timeInstance, timeInstance2 = 0, 0

local optionsFrame = {}
local cd = {} -- cooldown / throttle

local player = {
	expansion = GetAccountExpansionLevel(),
	realm = GetRealmName(),
	faction = select(2, UnitFactionGroup("player")),
	class = UnitClass("player"),
	race = UnitRace("player"),
	level = UnitLevel("player"),
	name = UnitName("player"),
	maxLevel = 85,
}

local BossIDs = { -- Instance Timer
--	[01-60] Classic
	1853, -- Darkmaster Gandling; Scholomance
	2748, -- Archaedas; Uldaman
	3975, -- Herod; Scarlet Monastery: Armory
	3977, -- High Inquisitor Whitemane; Scarlet Monastery: Cathedral
	3654, -- Mutanus the Devourer; Wailing Caverns
	4275, -- Archmage Arugal; Shadowfang Keep
	4421, -- Charlga Razorflank; Razorfen Kraul
	4543, -- Bloodmage Thalnos; Scarlet Monastery: Graveyard
	4829, -- Aku'mai; Blackfathom Deeps
	5709, -- Shade of Eranikus; Sunken Temple
	6487, -- Arcanist Doan; Scarlet Monastery: Library
	7267, -- Chief Ukorz Sandscalp; Zul'Farrak
	7358, -- Amnennar the Coldbringer; Razorfen Downs
	7800, -- Mekgineer Thermaplugg; Gnomeregan
	9018, -- High Interrogator Gerstahn; Blackrock Depths: Prison
	9019, -- Emperor Dagran Thaurissan; Blackrock Depths: Upper City
	9568, -- Overlord Wyrmthalak; Lower Blackrock Spire
	10813, -- Balnazzar; Stratholme: Main Gate
	11486, -- Prince Tortheldrin; Dire Maul: Capital Gardens
	11492, -- Alzzin the Wildshaper; Dire Maul: Warpwood Quarter
	11501, -- King Gordok; Dire Maul: Gordok Commons
	11520, -- Taragaman the Hungerer; Ragefire Chasm
	12201, -- Princess Theradras; Maraudon: Earth Song Falls
	12236, -- Lord Vyletongue; Maraudon: The Wicked Grotto
	12258, -- Razorlash; Maraudon: Foulspore Cavern
	45412, -- Lord Aurius Rivendare; Stratholme - Service Entrance
	46964, -- Lord Godfrey; Shadowfang Keep
	46254, -- Hogger; Stormwind Stockade
	47739, -- "Captain" Cookie; Deadmines -- yeah .. well this addon wasn't meant for running heroics ...
--	[60-70] The Burning Crusade
	16808, -- Warchief Kargath Bladefist; Hellfire Citadel: The Shattered Halls
	17377, -- Keli'dan the Breaker; Hellfire Citadel: The Blood Furnace
	17536, -- Nazan; Hellfire Citadel: Hellfire Ramparts
	17798, -- Warlord Kalithresh; Coilfang Reservoir: The Steamvault
	17881, -- Aeonus; Caverns of Time: The Black Morass
	17882, -- The Black Stalker; Coilfang Reservoir: The Underbog
	17942, -- Quagmirran; Coilfang Reservoir: The Slave Pens
	17977, -- Warp Splinter; Tempest Keep: The Botanica
	18344, -- Nexus-Prince Shaffar; Auchindoun: Mana-Tombs
	18373, -- Exarch Maladaar; Auchindoun: Auchenai Crypts
	18473, -- Talon King Ikiss; Auchindoun: Sethekk Halls
	18708, -- Murmur; Auchindoun: Shadow Labyrinth
	18096, -- Epoch Hunter; Caverns of Time: Old Hillsbrad Foothills
	19220, -- Pathaleon the Calculator; Tempest Keep: The Mechanar
	20912, -- Harbinger Skyriss; Tempest Keep: The Arcatraz
--	[70-80] Wrath of the Lich King
	26632, -- The Prophet Tharon'ja; Drak'Tharon Keep (name has an extra space at the end when transformed, GUID remains unchanged though)
	26723, -- Keristrasza; The Nexus: The Nexus
	26861, -- King Ymiron; Utgarde Keep: Utgarde Pinnacle
	27656, -- Ley-Guardian Eregos; The Nexus: The Oculus
	27978, -- Sjonnir The Ironshaper; Ulduar: Halls of Stone
	28923, -- Loken; Ulduar: Halls of Lightning
	29120, -- Anub'arak; Azjol-Nerub: Azjol-Nerub
	29306, -- Gal'darah; Gundrak
	29311, -- Herald Volazj; Azjol-Nerub: Ahn'kahet: The Old Kingdom
	31134, -- Cyanigosa; The Violet Hold
	36502, -- Devourer of Souls; Icecrown Citadel: The Forge of Souls
	36658, -- Scourgelord Tyrannus; Icecrown Citadel: Pit of Saron
--	23954, -- Ingvar the Plunderer; Utgarde Keep: Utgarde Pinnacle (dies 2x)
--	26533, -- Mal'Ganis; Caverns of Time: The Culling of Stratholme (no death)
--	35451, -- The Black Knight; Crusaders' Coliseum: Trial of the Champion (dies 3x)
--	36954, -- The Lich King; Icecrown Citadel: Halls of Reflection (no death)
--	[80-85] Cataclysm
	39705, -- Ascendant Lord Obsidius; Blackrock Caverns
	42333, -- High Priestess Azil; The Stonecore
	43875, -- Asaad; The Vortex Pinnacle
--	44566, -- Ozumat; Throne of the Tides [no death]
}

	------------------------------
	--- 02  Options & Defaults ---
	------------------------------

local defaults = {
	profile = {
		dingMessage = {
			L["dingMessage1"],
			L["dingMessage2"],
			L["dingMessage3"],
			L["dingMessage4"],                
			L["dingMessage5"],
			L["dingMessage6"],
		},
		outputFrame = 2,
		screenshotDelay = 1,
		announceDelay = 0,
		customSound = "Interface\\AddOns\\ReadySetDing\\Sounds\\MySoundFile.mp3",
		autoGratzDelay = 0,
		autoGratzCooldown = 60,
		autoGratzMsg = {
			"gz", -- 1
			"{rt1} gz {rt1}", -- 4
			"gz =)", -- 2
			"{rt3} gz {rt3}", -- 5
			"grats", -- 3
			"gratz [NAME]", -- 6
		},
		guildMemberAchievementFilter = true,
		guildMemberLevelFilter = 10,
		guildMemberMsg = L["guildMemberMsg"],
		instanceTimerMsg = L["instanceTimerMsg"],
	},
	char = {
	--	just needed a starting value ... so troublesome
		stats = {
			timeAFK = 0,
			totalAFK = 0,
			kills = 0,
			deaths = 0,
		},
	},
}

-- http://www.wowace.com/addons/ace3/pages/ace-config-3-0-options-tables/
local options = {
	type = "group",
	name = "",
	args = {
		Main = {
			type = "group",
			name = "\124cffADFF2FReadySet\124r|cffFFFFFFDing|r |cffB6CA00v0.80|r", -- Main Options Header
			handler = RSD,
			args = {
				toggleScreenshot = {
					type = "toggle",
					order = 1,
					desc = BINDING_NAME_SCREENSHOT,
					name = "|TInterface\\Icons\\inv_misc_spyglass_03:20:20:1:0"..iconCropped.."|t   "..L["Screenshot"],
					get = function(info) return RSD.db.profile.Screenshot end,
					set = function(info, value) RSD.db.profile.Screenshot = value end,
					disabled = "OptionsDisabled",
				},
				toggleAutoGratz = {
					type = "toggle",
					order = 3,
					descStyle = "",
					name = "|TInterface\\Icons\\INV_Misc_Gift_05:20:20:1:0"..iconCropped.."|t   "..L["Auto Gratz"],
					get = function(info) return RSD.db.profile.AutoGratz end,
					set = function(info, value) RSD.db.profile.AutoGratz = value end,
					disabled = "OptionsDisabled",
				},
				toggleGuildMemberDings = {
					type = "toggle",
					order = 5,
					descStyle = "",
					name = "|TInterface\\GuildFrame\\GuildLogo-NoLogo:20:20:1:0:64:64:14:51:14:51|t   "..L["Guild Dings"],
					get = function(info) return RSD.db.profile.GuildMemberDings end,
					set = function(info, value) RSD.db.profile.GuildMemberDings = value
						if IsInGuild() then
							if RSD.db.profile.GuildMemberDings then
								RSD.GuildRosterTimer = RSD:ScheduleRepeatingTimer(function() GuildRoster() end, 11)
							else
								RSD:CancelTimer(RSD.GuildRosterTimer)
							end
						end
					end,
					disabled = "OptionsDisabled",
				},
				toggleNormalAnnounce = {
					type = "toggle",
					order = 2,
					descStyle = "",
					name = "|TInterface\\Icons\\Ability_Warrior_RallyingCry:20:20:3:0:32:32:2:30:2:30|t   "..L["Normal Announce"],
					get = function(info) return RSD.db.profile.normalAnnounce end,
					set = function(info, value) RSD.db.profile.normalAnnounce = value end,
					disabled = "OptionsDisabled",
				},
				toggleGuildAnnounce = {
					type = "toggle",
					order = 4,
					descStyle = "",
					name = function() return RSD:GuildEmblem()..L["Guild Announce"] end,
					get = function(info) return RSD.db.profile.guildAnnounce end,
					set = function(info, value) RSD.db.profile.guildAnnounce = value end,
					disabled = "OptionsDisabled",
				},
				toggleBNetBroadcast = {
					type = "toggle",
					order = 6,
					desc = BN_BROADCAST_TOOLTIP,
					name = function()
						if time() > (cd.randomIcon1 or 0) then
							cd.randomIcon1 = time() + 120
							local a = random(1, 4)
							if	   a <= 2 then randomIcon1 = "PlusManz-BattleNet" -- \Data\enGB\locale-enGB.MPQ\Interface\FriendsFrame\PlusManz-BattleNet.blp
							elseif a == 3 then randomIcon1 = "Battlenet-WoWicon"
							elseif a == 4 then randomIcon1 = "Battlenet-Sc2icon"
							end
						end
						return "|TInterface\\FriendsFrame\\"..randomIcon1..":24|t  "..L["Real ID Broadcast"]
					end,
					get = function(info) return RSD.db.profile.BNetBroadcast end,
					set = function(info, value) RSD.db.profile.BNetBroadcast = value end,
					disabled = "OptionsDisabled",
				},
				inputDingMessage = {
					type = "input",
					order = 7,
					width = "full",
				--	multiline = true, -- prefer normal one over multiline
					name = " ", -- If it was like "" then usage wouldnt appear
					usage = legend,
					get = function(info) return RSD.db.profile.dingMessage[1] end,
					set = function(info, value) RSD.db.profile.dingMessage[1] = value
						RSD:ValidateMessage(value)
						if #strtrim(value) == 0 then RSD.db.profile.dingMessage[1] = defaults.profile.dingMessage[1] end
					end,
					disabled = function() return not RSD:IsEnabled() or RSD.db.profile.randomMessage end,
				},
				descriptionExample = {
					type = "description",
					order = 8,
					name = function() return "   "..RSD:ReplaceText(RSD.db.profile.dingMessage[1], "ExampleDingMsg") end,
				},
				header = {type = "header", order = 9, name = ""},
				descriptionLevelSummary = {
					type = "description",
					order = 10,
					name = function() RSD:UpdateSummary() return levelSummaryString or "" end,
				},
			},
		},
		Advanced = {
			type = "group",
			name = "",
			handler = RSD,
			args = {
				status1 = {
					type = "description",
					order = 1,
					name = function() return not RSD:IsEnabled() and " |cffA8A8FFNormal|r Dings: |cffFF2424Disabled|r" or RSD.db.profile.normalAnnounce and " |cffA8A8FFNormal|r Dings: |cffADFF2FAnnounce|r" or " |cffA8A8FFNormal|r Dings: |cffADFF2FLocal|r" end,
				},
				status2 = {
					type = "description",
					order = 2,
					name = function() return (not RSD:IsEnabled() or not RSD.db.profile.GuildMemberDings) and " |cff40FF40Guild|r Dings: |cffFF2424Disabled|r\n" or RSD.db.profile.guildMemberAnnounce and " |cff40FF40Guild|r Dings: |cffADFF2FAnnounce|r\n" or " |cff40FF40Guild|r Dings: |cffADFF2FLocal|r\n" end,
				},
				selectOutputFrame = {
					type = "select",
					order = 3,
					descStyle = "",
					name = "   Local Output Frame",
					values = function()
						local ChatWindows = {}
						local a = "|cff71D5FF"
						ChatWindows[1] = a.."#|r  UIErrorsFrame"
						ChatWindows[2] = a.."#|r  RaidWarningFrame"
						ChatWindows[3] = a.."#|r  RaidBossEmoteFrame"
						for i = 1, NUM_CHAT_WINDOWS do
							local b = GetChatWindowInfo(i)
							if #b > 0 then
								ChatWindows[i+3] = a..i..".|r "..b
							end
						end
						return ChatWindows
					end,
					get = function(info) return RSD.db.profile.outputFrame end,
					set = function(info, value) RSD.db.profile.outputFrame = value
						RSD:OutputFrame(nil, true)
					end,
					disabled = "OptionsDisabled",
				},
				header01 = {type = "header", order = 4, name = ""},
				toggleScreenshotHideUI = {
					type = "toggle",
					order = 5,
					width = "full",
					descStyle = "",
				--	this GlobalString might be confusing (Show/Hide)
					name = "|TInterface\\Icons\\INV_Gizmo_GoblingTonkController:20:20:1:1:64:64:4:60:4:60|t  "..L["Screenshot"]..": "..HIDE.." "..BUG_CATEGORY5,
					get = function(info) return RSD.db.profile.screenshotHideUI end,
					set = function(info, value) RSD.db.profile.screenshotHideUI = value end,
					disabled = function() return not RSD:IsEnabled() or not RSD.db.profile.Screenshot end,
				},
				toggleZoneAnnounce = {
					type = "toggle",
					order = 6,
					width = "full",
					descStyle = "",
					name = "|TInterface\\Icons\\Ability_Warrior_RallyingCry:20:20:1:0"..iconCropped.."|t  |cffFFACAC"..ZONE.."|r "..CHAT_ANNOUNCE,
					get = function(info) return RSD.db.profile.zoneAnnounce end,
					set = function(info, value) RSD.db.profile.zoneAnnounce = value end,
					disabled = "OptionsDisabled",
				},
				toggleRandomMessage = {
					type = "toggle",
					order = 7,
					width = "full",
					descStyle = "",
					name = "|TInterface\\AddOns\\ReadySetDing\\Images\\Awesome:24:24:-2:1|t Random Messages",
					get = function(info) return RSD.db.profile.randomMessage end,
					set = function(info, value) RSD.db.profile.randomMessage = value
						if value then
							ACD:Open("ReadySetDing_RandomMessage")
							InterfaceOptionsFrame:Hide()
						end
					end,
					disabled = "OptionsDisabled",
				},
				header02 = {type = "header", order = 8, name = ""},
				rangeScreenshotDelay = {
					type = "range",
					order = 9,
					desc = "|cffF6ADC6"..DEFAULT.."|r = 1 "..strlower(SECONDS),
					name = "|TInterface\\Icons\\inv_misc_spyglass_03:18:18:1:0"..iconCropped.."|t  "..L["Screenshot"].." "..L["Delay"],
					get = function(info) return RSD.db.profile.screenshotDelay end,
					set = function(info, value) RSD.db.profile.screenshotDelay = value end,
					min = 0, softMin = 0,
					max = 60, softMax = 2,
					step = 0.1,
					disabled = "OptionsDisabled",
				},
				newline01 = {type = "description", order = 10, name = ""},
				rangeAnnounceDelay = {
					type = "range",
					order = 11,
					desc = "|cffF6ADC6"..DEFAULT.."|r = 0 "..strlower(SECONDS),
					name = "|TInterface\\Icons\\Ability_Warrior_RallyingCry:18:18:1:0"..iconCropped.."|t  "..CHAT_ANNOUNCE.." "..L["Delay"],
					get = function(info) return RSD.db.profile.announceDelay end,
					set = function(info, value) RSD.db.profile.announceDelay = value end,
					min = 0, softMin = 0,
					max = 60, softMax = 10,
					step = 0.5,
					disabled = "OptionsDisabled",
				},
				header03 = {type = "header", order = 12, name = ""},
				inputCustomSound = {
					type = "input",
					order = 13,
					width = "full",
					desc = "WoW sound files are also possible",
					name = "   |TInterface\\Icons\\INV_Misc_Bell_01:22:22:0:3"..iconCropped.."|t  Custom |cffFFFFFFDing|r Sound",
					get = function(info) return RSD.db.profile.customSound end,
					set = function(info, value) RSD.db.profile.customSound = value
						if #strtrim(value) == 0 then RSD.db.profile.customSound = defaults.profile.customSound end
					end,
					disabled = "OptionsDisabled",
				},
				executeTestSound = {
					type = "execute",
					order = 14,
					width = "half",
					name = "Test",
					func = function() PlaySoundFile(profile.customSound, "Master") end,
					disabled = "OptionsDisabled",
				},
			},
		},
		AutoGratz = {
			type = "group",
			name = "|cffFFFFFF"..L["Auto Gratz"].."|r",
			handler = RSD,
			args = {
				status = {
					type = "description",
					order = 1,
					name = function() return (not RSD:IsEnabled() or not RSD.db.profile.AutoGratz) and " |cffFF2424Disabled|r" or " |cffADFF2FEnabled|r" end,
				},
				toggleGratzAllAchievements = {
					type = "toggle",
					order = 2,
					width = "full",
					descStyle = "",
					name = "|TInterface\\Icons\\Achievement_Reputation_06:20:20:1:1"..iconCropped.."|t  Triggers on all |cffFFFF00"..ACHIEVEMENTS.."|r",
					get = function(info) return RSD.db.profile.gratzAllAchievements end,
					set = function(info, value) RSD.db.profile.gratzAllAchievements = value end,
					disabled = "OptionsDisabled",
				},
				header01 = {type = "header", order = 3, name = ""},
				rangeAutoGratzDelay = {
					type = "range",
					order = 4,
					desc = "|cffF6ADC6"..DEFAULT.."|r = 0 "..strlower(SECONDS).." (|cffFF8000Random|r)",
					name = L["Delay"],
					get = function(info) return RSD.db.profile.autoGratzDelay end,
					set = function(info, value) RSD.db.profile.autoGratzDelay = value end,
					min = 0, softMin = 0,
					max = 60, softMax = 10,
					step = 0.5,
					disabled = "OptionsDisabled",
				},
				newline01 = {type = "description", order = 5, name = ""},
				rangeAutoGratzCooldown = {
					type = "range",
					order = 6,
					desc = "|cffF6ADC6"..DEFAULT.."|r = 60 "..strlower(SECONDS),
					name = L["Cooldown"],
					get = function(info) return RSD.db.profile.autoGratzCooldown end,
					set = function(info, value) RSD.db.profile.autoGratzCooldown = value end,
					min = 0, softMin = 0,
					max = 600, softMax = 120,
					step = 1,
					disabled = "OptionsDisabled",
				},
				header02 = {type = "header", order = 7, name = ""},
				inputAutoGratzMsg1 = {
					type = "input",
					order = 8,
					descStyle = "",
					name = "",
					get = function(info) return RSD.db.profile.autoGratzMsg[1] end,
					set = function(info, value) RSD.db.profile.autoGratzMsg[1] = value
						if #strtrim(value) == 0 then RSD.db.profile.autoGratzMsg[1] = defaults.profile.autoGratzMsg[1] end end,
					disabled = "OptionsDisabled",
				},
				inputAutoGratzMsg2 = {
					type = "input",
					order = 9,
					descStyle = "",
					name = "",
					get = function(info) return RSD.db.profile.autoGratzMsg[2] end,
					set = function(info, value) RSD.db.profile.autoGratzMsg[2] = value
						if #strtrim(value) == 0 then RSD.db.profile.autoGratzMsg[2] = defaults.profile.autoGratzMsg[2] end end,
					disabled = "OptionsDisabled",
				},
				inputAutoGratzMsg3 = {
					type = "input",
					order = 10,
					descStyle = "",
					name = "",
					get = function(info) return RSD.db.profile.autoGratzMsg[3] end,
					set = function(info, value) RSD.db.profile.autoGratzMsg[3] = value
						if #strtrim(value) == 0 then RSD.db.profile.autoGratzMsg[3] = defaults.profile.autoGratzMsg[3] end end,
					disabled = "OptionsDisabled",
				},
				inputAutoGratzMsg4 = {
					type = "input",
					order = 11,
					descStyle = "",
					name = "",
					get = function(info) return RSD.db.profile.autoGratzMsg[4] end,
					set = function(info, value) RSD.db.profile.autoGratzMsg[4] = value
						if #strtrim(value) == 0 then RSD.db.profile.autoGratzMsg[4] = defaults.profile.autoGratzMsg[4] end end,
					disabled = "OptionsDisabled",
				},
				inputAutoGratzMsg5 = {
					type = "input",
					order = 12,
					descStyle = "",
					name = "",
					get = function(info) return RSD.db.profile.autoGratzMsg[5] end,
					set = function(info, value) RSD.db.profile.autoGratzMsg[5] = value
						if #strtrim(value) == 0 then RSD.db.profile.autoGratzMsg[5] = defaults.profile.autoGratzMsg[5] end end,
					disabled = "OptionsDisabled",
				},
				inputAutoGratzMsg6 = {
					type = "input",
					order = 13,
					descStyle = "",
					name = "",
					get = function(info) return RSD.db.profile.autoGratzMsg[6] end,
					set = function(info, value) RSD.db.profile.autoGratzMsg[6] = value
						if #strtrim(value) == 0 then RSD.db.profile.autoGratzMsg[6] = defaults.profile.autoGratzMsg[6] end end,
					disabled = "OptionsDisabled",
				},
			},
		},
		GuildMemberDings = {
			type = "group",
			name = "|cffFFFFFF"..L["Guild Dings"].."|r",
			handler = RSD,
			args = {
				status = {
					type = "description",
					order = 1,
					name = function() return (not RSD:IsEnabled() or not RSD.db.profile.GuildMemberDings) and " |cffFF2424Disabled|r" or " |cffADFF2FEnabled|r" end,
				},
				toggleGuildMemberAnnounce = {
					type = "toggle",
					order = 2,
					width = "full",
					descStyle = "",
					name = "|TInterface\\Icons\\Ability_Warrior_RallyingCry:20:20:1:0"..iconCropped.."|t  "..L["Guild Announce"],
					get = function(info) return RSD.db.profile.guildMemberAnnounce end,
					set = function(info, value) RSD.db.profile.guildMemberAnnounce = value end,
					disabled = function() return (not RSD:IsEnabled() or not RSD.db.profile.GuildMemberDings) end,
				},
				toggleGuildMemberAchievementFiter = {
					type = "toggle",
					order = 3,
					width = "full",
					desc = LEVEL.." |cffB6CA0010|r, |cffB6CA0020|r, |cffB6CA0030|r, ...|r",
					name = function()
						if time() > (cd.randomIcon2 or 0) then
							cd.randomIcon2 = time() + 60
							randomIcon2 = math.random(1, 9)*10
							if randomIcon2 == 90 then randomIcon2 = 85 end
						end
						return "|TInterface\\Icons\\Achievement_Level_"..randomIcon2..":20:20:1:0"..iconCropped.."|t  |cffFFFF00"..ACHIEVEMENTS.."|r "..FILTER
					end,
					get = function(info) return RSD.db.profile.guildMemberAchievementFilter end,
					set = function(info, value) RSD.db.profile.guildMemberAchievementFilter = value end,
					disabled = "OptionsDisabled",
				},
				header01 = {type = "header", order = 4, name = ""},
				rangeGuildMemberFilter = {
					type = "range",
					order = 5,
					desc = "|cffF6ADC6"..DEFAULT.."|r = "..LEVEL.." 20",
					name = "|TInterface\\Icons\\Trade_Engineering:20:20:1:1"..iconCropped.."|t  "..LEVEL.." "..FILTER,
					get = function(info) return RSD.db.profile.guildMemberLevelFilter end,
					set = function(info, value) RSD.db.profile.guildMemberLevelFilter = value end,
					min = 2,
					max = 85,
					step = 1,
					disabled = "OptionsDisabled",
				},
				header02 = {type = "header", order = 6, name = ""},
				inputGuildMemberMsg = {
					type = "input",
					order = 7,
					width = "full",
					name = " ",
					usage = "\n|cff71D5FF[NAME]|r |cffFFFFFF= "..NAME.."|r\n|cffF6ADC6[LEVEL-]|r |cffFFFFFF= "..L["Previous Level"].."|r\n|cffADFF2F[LEVEL] |cffFFFFFF= "..L["New Level"].."|r\n|cff71D5FF[CLASS]|r |cffFFFFFF= "..CLASS.."|r\n|cffADFF2F[RANK]|r |cffFFFFFF= "..RANK.."|r\n|cffF6ADC6[ZONE]|r |cffFFFFFF= "..ZONE.."|r\n|cff71D5FF[TIME]|r |cffFFFFFF=|r |cffF6ADC6RealTime|r\n|cffB6CA00[SPEED]|r |cffFFFFFF= "..L["LevelSpeed"].."|r",
					get = function(info) return RSD.db.profile.guildMemberMsg end,
					set = function(info, value) RSD.db.profile.guildMemberMsg = value
						if #strtrim(value) == 0 then RSD.db.profile.guildMemberMsg = defaults.profile.guildMemberMsg end
					end,
					disabled = "OptionsDisabled",
				},
				descriptionExample = {
					type = "description",
					order = 8,
					name = function()
						local a = GetNumGuildMembers()
					--	GetNumGuildMembers returns 0 early in the game
						if IsInGuild() and a > 0 then
							local name, rank, _, level, class, zone, _, _, _, _, classFileName = GetGuildRosterInfo(random(1, a))
							if level == 85 then level = 84 end -- wow .. someone dinged level 86 :)
							return "   "..RSD:ReplaceTextG(RSD.db.profile.guildMemberMsg, "xGUILDMEMBERMSG", name, level+1, class, rank, zone, " in "..RSD:TimetoString(random(600, 7200)), " ("..format("%.2f", random(10, 30)/10).." "..Hour.."/"..LEVEL..")", classFileName)
						else
							return "   |cffF6ADC6"..L["[No Data]"].."|r"
						end
					end,
				},
				description2 = {
					type = "description",
					order = 9,
					name = "\n\n\n\n\n\n\n\n\n\n\n  |cff71D5FF[TIME]|r = |cffF6ADC6Actual real world time|r (!)\n\n  Autogratz Example:  |cffADFF2F\"gz on level |cffFFFFFF[LEVEL], [NAME]!\"|r",
				},
			},
		},
		InstanceTimer = {
			type = "group",
			name = "|cffFFFFFF"..L["Instance Timer"].."|r",
			handler = RSD,
			args = {
				status = {
					type = "description",
					order = 1,
					name = function() return  end
				},
				toggleInstanceTimer = {
					type = "toggle",
					order = 2,
					descStyle = "",
					width = "full",
					name = function() local a = (not RSD:IsEnabled() or not RSD.db.profile.instanceTimer) and "|cffFF2424Disabled|r" or "|cffADFF2FEnabled|r" return "|TInterface\\Icons\\Spell_Holy_BorrowedTime:20:20:1:0"..iconCropped.."|t  "..a end,
					get = function(info) return RSD.db.profile.instanceTimer end,
					set = function(info, value) RSD.db.profile.instanceTimer = value end,
					disabled = "OptionsDisabled",
				},
				inputInstanceTimerMsg = {
					type = "input",
					order = 3,
					width = "full",
					name = " ",
					usage = "\n|cff58ACFA[INSTANCE]|r |cffFFFFFF= Instance|r\n|cff71D5FF[TIME]|r |cffFFFFFF= Time|r\n[START]|r |cffFFFFFF= Start Time|r\n|cffADFF2F|cffF6ADC6[END]|r |cffFFFFFF= End Time|r",
					get = function(info) return RSD.db.profile.instanceTimerMsg end,
					set = function(info, value) RSD.db.profile.instanceTimerMsg = value
						if #strtrim(value) == 0 then RSD.db.profile.instanceTimerMsg = defaults.profile.instanceTimerMsg end end,
					disabled = "OptionsDisabled",
				},
				descriptionExample = {
					type = "description",
					order = 4,
					name = function() return "   "..RSD:ReplaceTextI(RSD.db.profile.instanceTimerMsg, "xInstanceTimerMsg") end,
				},
				description = {
					type = "description",
					order = 5,
					name = "\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n",
				},
				executePrintInstanceTimer = {
					type = "execute",
					order = 6,
					descStyle = "",
					name = "|TInterface\\Icons\\INV_Misc_Note_01:18:18:1:0"..iconCropped.."|t |cffFFFFFFInstance Data|r",
					func = function()
						if RSD.db.char.timeInstanceList then -- http://forums.wowace.com/showthread.php?p=306562#post306562
							local t = {}
							local i = 1
							for k, v in pairs(RSD.db.char.timeInstanceList) do
								t[i] = k
								i = i + 1
							end
							sort(t)
							for i = 1, #t do
								print(t[i].." "..RSD.db.char.timeInstanceList[t[i]])
							end
						end
					end,
					disabled = "OptionsDisabled",
				},
			},
		},
		Stats = {
			type = "group",
			name = "",
			handler = RSD,
			args = {
				descriptionQuests = {
					type = "description",
					order = 1,
					name = function() return " "..QUESTS_LABEL.." = |cffB6CA00"..RSD:AchievementStatistics("QUESTS").."|r" end,
				},
				descriptionXP = {
					type = "description",
					order = 2,
					name = function() return " "..COMBAT_XP_GAIN.." = |cffB6CA00"..UnitXP("player").."|r / |cff71D5FF"..UnitXPMax("player").."|r = |cffADFF2F"..floor((UnitXP("player")/UnitXPMax("player"))*100).."%|r" end,
				},
				descriptionLevelDiff = {
					type = "description",
					order = 3,
					name = function()
						if RSD:TimeDiff("exampleMsg") ~= L["[No Data]"] then
							return " "..L["Current Diff"].." = |cff71D5FF"..RSD:TimeDiff("exampleMsg").."|r\n"
						else
							return " "..L["Current Diff"].." = |cffF6ADC6"..L["[No Data]"].."|r\n"
						end
					end,
				},
				descriptionlastLevelDate = {
					type = "description",
					order = 4,
					name = function()
						for i = player.maxLevel, 2, -1 do
							local a = RSD.db.char.dateStampList[i]
							if a then
								return " "..L["Last Levelup"].." (|cff71D5FF"..i.."|r) = |cffB6CA00"..a.."|r"
							end
						end
						return " "..L["Last Levelup"].." = |cffF6ADC6"..L["[No Data]"].."|r"
					end,
				},
				descriptionRealTime = {
					type = "description",
					order = 5,
					name = function()
					--	why is realTimeList not yet defined?
						if RSD.db.char.realTimeList then
							for i = player.maxLevel, 2, -1 do
								local a = RSD.db.char.realTimeList[i]
								if a then
									return " Realtime Since Levelup = |cffB6CA00"..RSD:TimetoString(time()-a).."|r\n"
								end
							end
							return " Realtime Since Levelup = |cffF6ADC6"..L["[No Data]"].."|r".."\n"
						end
					end,
				},
				descriptionLevelSpeed = {
					type = "description",
					order = 6,
					name = function()
						if RSD:RecentLevelSpeed() ~= L["[No Data]"] then
							return " "..L["LevelSpeed"].." = |cffB6CA00"..format("%.2f", RSD:RecentLevelSpeed()/3600).."|r "..Hour.."/"..LEVEL
						else
							return " "..L["LevelSpeed"].." = |cffF6ADC6"..L["[No Data]"].."|r"
						end
					end,
				},
				descriptionLevelSpeedAvg = {
					type = "description",
					order = 7,
					name = function()
						if player.level > 1 then
							return " "..L["Average LevelSpeed"].." = |cff71D5FF"..format("%.2f", ((TPM_totalTime+RSD:AddedTime())/3600)/(player.level-1)).."|r "..Hour.."/"..LEVEL.."\n"
						else
							return " "..L["Average LevelSpeed"].." = |cffF6ADC6"..L["[No Data]"].."|r\n"
						end
					end,
				},
				descriptionTimeAFK1 = {
					type = "description",
					order = 8,
					name = function() return " "..L["AFK Time"].." = |cffB6CA00"..RSD:TimetoString(RSD.db.char.stats.timeAFK).."|r" end,
				},
				descriptionTimeAFK2 = {
					type = "description",
					order = 9,
					name = function() return " "..L["Total AFK Time"].." = |cff71D5FF"..RSD:TimetoString(RSD.db.char.stats.totalAFK).."|r\n" end,
				},
				descriptionKills = {
					type = "description",
					order = 10,
					name = function() return " "..L["Kills"].." = |cffFF0000"..RSD.db.char.stats.kills.."|r, "..L["Total Kills"].." = |cffFF0000"..RSD:AchievementStatistics("KILLS").."|r" end,
				},
				descriptionDeaths = {
					type = "description",
					order = 11,
					name = function() return " "..L["Deaths"].." = |cffFF0000"..RSD.db.char.stats.deaths.."|r, "..L["Total Deaths"].." = |cffFF0000"..RSD:AchievementStatistics("DEATHS").."|r\n" end,
				},
				header02 = {
					type = "header",
					order = 12,
					name = "",
				},
				executePrintLevelData = {
					type = "execute",
					order = 13,
					name = "|TInterface\\Icons\\INV_Misc_Note_01:18:18:1:0"..iconCropped.."|t |cffFFFFFFLevel Data|r",
					func = function()
						for i = 2, player.maxLevel do
							local a = RSD.db.char.levelTimeList[i]
							if a then
								print(LEVEL.." |cffF6ADC6"..(i-1).."|r - |cff71D5FF"..i.."|r: |cffB6CA00"..RSD:TimetoString(a).."|r   "..L["Total"]..": |cff71D5FF"..RSD:TimetoString(RSD.db.char.totalTimeList[i]).."|r")
							end
						end
					end,
					disabled = "OptionsDisabled",
				},
				newline01 = {type = "description", order = 14, name = ""},
				executeExportData = {
					type = "execute",
					order = 15,
					name = "|TInterface\\Icons\\Trade_Engineering:18:18:1:0"..iconCropped.."|t |cffFFFFFFExport|r",
					func = function() RSD:ExportData() end,
					disabled = "OptionsDisabled",
				},
				newline02 = {type = "description", order = 16, name = ""},
				executePlaySound = {
					type = "execute",
					order = 17,
					name = "|TSPELLS\\HOLIDAYS\\Heart:18|t |cffF6ADC6Play Sound|r", -- ...\Data\common.MPQ\SPELLS\HOLIDAYS\Heart.blp
					func = function()
						if time() > (cd.playSound or 0) then
							cd.playSound = time() + 3
							local descInterface = " /run |cffB6CA00PlaySoundFile(\"Sound\\\\Interface\\\\|r|cff71D5FF"
							local descSpell = " /run |cffB6CA00PlaySoundFile(\"Sound\\\\Spells\\\\|r|cff71D5FF"
							local descEnd = "|r|cffB6CA00.ogg\")|r\n"
							local a = random(1, 4)

							if a == 1 then PSF("Sound\\Interface\\LevelUp.ogg"); soundPath = descInterface.."LevelUp"..descEnd -- ...\Data\sound.MPQ\Sound\Interface\LevelUp.ogg -- Player Leveled Up
							elseif a == 2 then PSF("Sound\\Interface\\iQuestComplete.ogg"); soundPath = descInterface.."iQuestComplete"..descEnd -- ...\Data\sound.MPQ\Sound\Interface\iQuestComplete.ogg -- Quest Comepleted
							elseif a == 3 then PSF("Sound\\Spells\\AchievmentSound1.ogg"); soundPath = descSpell.."AchievmentSound1"..descEnd -- ...\Data\sound.MPQ\Sound\Spells\AchievmentSound1.ogg -- Achievement Gained
							elseif a == 4 then PSF("Sound\\Spells\\Resurrection.ogg"); soundPath = descSpell.."Resurrection"..descEnd -- ...\Data\sound.MPQ\Sound\Spells\Resurrection.ogg -- Resurrection
							end
						end
					end,
					disabled = "OptionsDisabled",
				},
				descriptionSound = {
					type = "description",
					order = 18,
					name = function() -- Sound File Path
						if time() < (cd.playSound or 0) then
							return soundPath
						else
							return "\n"
						end
					end,
				},
				descriptionWindows7 = { -- yes i'm a micro$oft fanboi .. Windows 7 FTW! .. Tux just Sux
					type = "description",
					order = 19,
					name = function() return " |cff71D5FFTo Do|r |cffB6CA00v0.81+|r\n # |cffADFF2FDings / Gratz|r: Friend List, Party Member\n # |cffADFF2FLevelSpeed|r Ranking/Sorting\n # |cffADFF2FLibDataBroker|r Support\n|TInterface\\AddOns\\ReadySetDing\\Images\\ReadySet7:32:128:170:-15|t" end,
				},
			},
		},
		RandomMessage = {
			type = "group",
			name = "|TInterface\\AddOns\\ReadySetDing\\Images\\Awesome:24:24:0:5|t  Random Messages",
			handler = RSD,
			args = {
				description = {
					type = "description",
					order = 1,
					name = "  Note: This part is kinda experimental, I'm a noob with frames / AceGUI ...",
				},			
				input1 = {
					type = "input",
					order = 2,
					width = "full",
					name = " ",
					usage = legend,
					get = function(info) return RSD.db.profile.dingMessage[2] end,
					set = function(info, value) RSD.db.profile.dingMessage[2] = value
						if #strtrim(value) == 0 then RSD.db.profile.dingMessage[2] = defaults.profile.dingMessage[2] end
						RSD:ValidateMessage(value)
					end,
					disabled = "OptionsDisabled",
				},
				description1 = {
					type = "description",
					order = 3,
					name = function() return "   "..RSD:ReplaceText(RSD.db.profile.dingMessage[2], "ExampleDingMsg").."\n\n" end,
				},
				input2 = {
					type = "input",
					order = 4,
					width = "full",
					name = "",
					get = function(info) return RSD.db.profile.dingMessage[3] end,
					set = function(info, value) RSD.db.profile.dingMessage[3] = value
						if #strtrim(value) == 0 then RSD.db.profile.dingMessage[3] = defaults.profile.dingMessage[3] end
						RSD:ValidateMessage(value)
					end,
					disabled = "OptionsDisabled",
				},
				description2 = {
					type = "description",
					order = 5,
					name = function() return "   "..RSD:ReplaceText(RSD.db.profile.dingMessage[3], "ExampleDingMsg").."\n\n" end,
				},
				input3 = {
					type = "input",
					order = 6,
					width = "full",
					name = "",
					get = function(info) return RSD.db.profile.dingMessage[4] end,
					set = function(info, value) RSD.db.profile.dingMessage[4] = value
						if #strtrim(value) == 0 then RSD.db.profile.dingMessage[4] = defaults.profile.dingMessage[4] end
						RSD:ValidateMessage(value)
					end,
					disabled = "OptionsDisabled",
				},
				description3 = {
					type = "description",
					order = 7,
					name = function() return "   "..RSD:ReplaceText(RSD.db.profile.dingMessage[4], "ExampleDingMsg").."\n\n" end,
				},
				input4 = {
					type = "input",
					order = 8,
					width = "full",
					name = "",
					get = function(info) return RSD.db.profile.dingMessage[5] end,
					set = function(info, value) RSD.db.profile.dingMessage[5] = value
						if #strtrim(value) == 0 then RSD.db.profile.dingMessage[5] = defaults.profile.dingMessage[5] end
						RSD:ValidateMessage(value)
					end,
					disabled = "OptionsDisabled",
				},
				description4 = {
					type = "description",
					order = 9,
					name = function() return "   "..RSD:ReplaceText(RSD.db.profile.dingMessage[5], "ExampleDingMsg").."\n\n" end,
				},
				input5 = {
					type = "input",
					order = 10,
					width = "full",
					name = "",
					get = function(info) return RSD.db.profile.dingMessage[6] end,
					set = function(info, value) RSD.db.profile.dingMessage[6] = value
						if #strtrim(value) == 0 then RSD.db.profile.dingMessage[6] = defaults.profile.dingMessage[6] end
						RSD:ValidateMessage(value)
					end,
					disabled = "OptionsDisabled",
				},
				description5 = {
					type = "description",
					order = 11,
					name = function() return "   "..RSD:ReplaceText(RSD.db.profile.dingMessage[6], "ExampleDingMsg").."\n\n" end,
				},
			},
		},
	},
}

	----------------------------------------------
	---- 03  OnInitialize, OnEnable, OnDisable ---
	----------------------------------------------

function RSD:OnInitialize()

--	http://www.wowace.com/addons/ace3/pages/api/ace-db-3-0/
	self.db = LibStub("AceDB-3.0"):New("ReadySetDingDB", defaults, true)

--	table reference shortcuts
	profile, realm, char = self.db.profile, self.db.realm, self.db.char
	stats = char.stats
	
	self.db.global.version = 0.80
	self.db.global.fileType = "Release"

--	http://www.wowace.com/addons/ace3/pages/api/ace-config-registry-3-0/
	ACR:RegisterOptionsTable("ReadySetDing_Main", options.args.Main)
	ACR:RegisterOptionsTable("ReadySetDing_Screenshot", options.args.Advanced)
	ACR:RegisterOptionsTable("ReadySetDing_AutoGratz", options.args.AutoGratz)
	ACR:RegisterOptionsTable("ReadySetDing_GuildMemberDings", options.args.GuildMemberDings)
	ACR:RegisterOptionsTable("ReadySetDing_InstanceTimer", options.args.InstanceTimer)
	ACR:RegisterOptionsTable("ReadySetDing_Stats", options.args.Stats)
	ACR:RegisterOptionsTable("ReadySetDing_RandomMessage", options.args.RandomMessage)

--	http://www.wowace.com/addons/ace3/pages/api/ace-dboptions-3-0/
	options.args.Profiles = LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db)
	ACR:RegisterOptionsTable("ReadySetDing_Profiles", options.args.Profiles)

--	http://www.wowace.com/addons/ace3/pages/api/ace-config-dialog-3-0/
	optionsFrame.Main = ACD:AddToBlizOptions("ReadySetDing_Main", Main)
	optionsFrame.Advanced = ACD:AddToBlizOptions("ReadySetDing_Screenshot", "|TInterface\\Icons\\Trade_Engineering:18:18:1:0"..iconCropped.."|t  "..ADVANCED_LABEL, Main)
	optionsFrame.AutoGratz = ACD:AddToBlizOptions("ReadySetDing_AutoGratz", "|TInterface\\Icons\\INV_Misc_Gift_05:18:18:1:0"..iconCropped.."|t  "..L["Auto Gratz"], Main)
	optionsFrame.GuildMemberDings = ACD:AddToBlizOptions("ReadySetDing_GuildMemberDings", "|TInterface\\GuildFrame\\GuildLogo-NoLogo:18:18:1:0:64:64:14:51:14:51|t  "..L["Guild Dings"], Main)
	optionsFrame.InstanceTimer = ACD:AddToBlizOptions("ReadySetDing_InstanceTimer", "|TInterface\\Icons\\Spell_Holy_BorrowedTime:18:18:1:0"..iconCropped.."|t  "..L["Instance Timer"], Main)
	optionsFrame.Stats = ACD:AddToBlizOptions("ReadySetDing_Stats", "|TInterface\\Icons\\INV_Misc_QuestionMark:18:18:1:0"..iconCropped.."|t  "..L["Stats"], Main)
	optionsFrame.Profiles = ACD:AddToBlizOptions("ReadySetDing_Profiles", "|TInterface\\Icons\\INV_Misc_Note_01:18:18:1:0"..iconCropped.."|t  "..L["Profiles"], Main)

--	http://www.wowace.com/addons/ace3/pages/api/ace-console-3-0/
	self:RegisterChatCommand("rsd", "SlashCommand")
	self:RegisterChatCommand("readyset", "SlashCommand")
	self:RegisterChatCommand("readysetding", "SlashCommand")

--	Define AceDB saved variables if not yet defined
--	need full table reference patchs, because of all the tables being destroyed by AceDB:ResetDB()
	self.db.char.levelTimeList = self.db.char.levelTimeList or {}
	self.db.char.totalTimeList = self.db.char.totalTimeList or {}
	self.db.char.realTimeList = self.db.char.realTimeList or {}
	self.db.char.dateStampList = self.db.char.dateStampList or {}
	self.db.char.timeInstanceList = self.db.char.timeInstanceList or {}
	self.db.char.levelSummary = self.db.char.levelSummary or {}
end

function RSD:OnEnable()

--	http://www.wowace.com/addons/ace3/pages/api/ace-event-3-0/
	self:RegisterEvent("PLAYER_LEVEL_UP")
	self:RegisterEvent("TIME_PLAYED_MSG")

	self:RegisterEvent("GUILD_ROSTER_UPDATE") -- Guild Member Dings
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED") -- Instance Timer, Player Deaths
	self:RegisterEvent("CHAT_MSG_CHANNEL_NOTICE") -- Instance Timer
	self:RegisterEvent("LFG_PROPOSAL_SUCCEEDED") -- Instance Timer (Backup Timer)
	self:RegisterEvent("CHAT_MSG_MONSTER_YELL") -- Instance Timer
	self:RegisterEvent("CHAT_MSG_PARTY") -- Auto Gratz
	self:RegisterEvent("CHAT_MSG_GUILD") -- Auto Gratz
	self:RegisterEvent("CHAT_MSG_GUILD_ACHIEVEMENT") -- Auto Gratz
	self:RegisterEvent("CHAT_MSG_SYSTEM") -- AFK Time, Instance Timer Reset
	self:RegisterEvent("PLAYER_LEAVING_WORLD") -- AFK Time

--	http://www.wowace.com/addons/ace3/pages/api/ace-timer-3-0/
--	wait (7 sec) for other AddOns first that want to request /played
	self:ScheduleTimer(function()
		if TPM_totalTime == 0 then
			RequestTimePlayed()
		end
	end, 7) -- 777!

--	refresh Guild Roster with repeating AceTimer
--	server side throttle on GuildRoster() is 10 seconds*
	if profile.GuildMemberDings then
		self.GuildRosterTimer = self:ScheduleRepeatingTimer(function() GuildRoster() end, 11)
	end
end

function RSD:OnDisable()
	self:UnregisterAllEvents()
	self:CancelAllTimers()
end

	------------------------------
	--- 04  Callback Functions ---
	------------------------------

-- gray out options when AddOn disabled
function RSD:OptionsDisabled()
	return not self:IsEnabled()
end

function RSD:SlashCommand(input)

	if #strtrim(input) == 0 then
		InterfaceOptionsFrame_OpenToCategory(optionsFrame.Main)
	--	automatically expand the InterfaceOptionsFrame options by "clicking" it
		for i = 1, #InterfaceOptionsFrameAddOns.buttons do
			if _G["InterfaceOptionsFrameAddOnsButton"..i]:GetText() == Main and optionsFrame.Main.collapsed then
				_G["InterfaceOptionsFrameAddOnsButton"..i.."Toggle"]:Click()
			end
		end

	elseif input == "enable" then
		if not self:IsEnabled() then
			self:Enable()
			self:Print("|cffADFF2FEnabled|r")
		end
		self:NotifyChange()

	elseif input == "disable" then
		if self:IsEnabled() then
			self:Disable()
			self:Print("|cffFF2424Disabled|r")
		end
		self:NotifyChange()
		
	elseif input == "advanced" or input == "adv" then
		InterfaceOptionsFrame_OpenToCategory(optionsFrame.Advanced)
	elseif input == "autogratz" or input == "gratz" or input == "grats" or input == "gz" then
		InterfaceOptionsFrame_OpenToCategory(optionsFrame.AutoGratz)
	elseif input == "guilddings" or input == "guild" or input == "dings" or input == "ding" then
		InterfaceOptionsFrame_OpenToCategory(optionsFrame.GuildMemberDings)
	elseif input == "instancetimer" or input == "instance" or input == "inst" or input == "timer" then
		InterfaceOptionsFrame_OpenToCategory(optionsFrame.InstanceTimer)
	elseif input == "stats" or input == "stat" or input == "st" then
		InterfaceOptionsFrame_OpenToCategory(optionsFrame.Stats)
	elseif input == "profiles" or input == "prof" then
		InterfaceOptionsFrame_OpenToCategory(optionsFrame.Profiles)
		
	elseif input == "export" or input == "exp" or input == "xp" then
		RSD:ExportData(true)

	else
		print("/rsd |cffADFF2Fenable|r: Enable AddOn\n/rsd |cffFF2424disable|r: Disable AddOn\n/rsd |cffFFFF00advanced|r: Open Advanced\n/rsd |cffFFFF00gratz|r: Open AutoGratz\n/rsd |cffFFFF00guild|r: Open Guild Dings\n/rsd |cffFFFF00instance|r: Open Instance Timer\n/rsd |cffFFFF00stats|r: Open Stats\n/rsd |cffFFFF00profiles|r: Open Profiles\n/rsd |cff71D5FFexport|r: Export to |cffFFFF00"..SLASH_SAY2.."|r (|cffFF2424SPAM!|r)")
	end
end

-- refresh all menus
function RSD:NotifyChange()
	ACR:NotifyChange("ReadySetDing_Main")
	ACR:NotifyChange("ReadySetDing_Screenshot")
	ACR:NotifyChange("ReadySetDing_AutoGratz")
	ACR:NotifyChange("ReadySetDing_GuildMemberDings")
	ACR:NotifyChange("ReadySetDing_InstanceTimer")
	ACR:NotifyChange("ReadySetDing_Stats")
end

function RSD:GuildEmblem()
	if GuildFrameTabardEmblem then
	--	creating new tables = bad, i think. it gets GC'ed right? dont know how to do it without the table
		char.guildTexCoord = {GuildFrameTabardEmblem:GetTexCoord()}
	end
	if IsInGuild() and char.guildTexCoord then
	--	http://www.wowpedia.org/API_Texture_SetTexCoord
		return "|TInterface\\GuildFrame\\GuildEmblemsLG_01:32:32:-5:1:32:32:"..(char.guildTexCoord[1]*32)..":"..(char.guildTexCoord[7]*32)..":"..(char.guildTexCoord[2]*32)..":"..(char.guildTexCoord[8]*32).."|t"
	else
		return "|TInterface\\GuildFrame\\GuildLogo-NoLogo:32:32:-5:1|t"
	end
end

function RSD:TimetoString(value, dotZero)
	local seconds = mod(floor(value), 60)
	local minutes = mod(floor(value/60), 60)
	local hours = mod(floor(value/3600), 24)
	local days = floor(value/86400)
	
--	use some Button to get rid of the pipe characters (|)
--	of the "grammar" UI escape sequences Global Strings
--	so that they can be used in SendChatMessage()
	local f_seconds = bttn:GetText(bttn:SetFormattedText(D_SECONDS, seconds))
	local f_minutes = bttn:GetText(bttn:SetFormattedText(D_MINUTES, minutes))
	local f_hours = bttn:GetText(bttn:SetFormattedText(D_HOURS, hours))
	local f_days = bttn:GetText(bttn:SetFormattedText(D_DAYS, days))

	if value >= 0 and value < 60 then
		return f_seconds
	elseif value >= 60 and value < 3600 then
	--	need the .0 for in a nicer looking level summary
		if seconds >= 6 or dotZero then
			return bttn:GetText(bttn:SetFormattedText(D_MINUTES2, tonumber(minutes.."."..format("%.0f",floor(seconds/6)))))
		else
			return f_minutes
		end
	elseif value >= 3600 and value < 86400 then
		if minutes > 0 then
			return f_hours..", "..f_minutes
		else
			return f_hours
		end
	elseif value >= 86400 then
		if hours > 0 then
			return f_days..", "..f_hours
		else
			return f_days
		end
	end
end

function RSD:AddedTime()
	return time() - lastPlayedRequest
end

function RSD:TimeDiff(info)
	local timeDiff = 0
	local color1A, color1B, escape
	if char.levelTimeList[player.level] then
		if info == "exampleMsg" then
			timeDiff = char.levelTimeList[player.level] - (TPM_currentLevelTime+self:AddedTime())
			color1A, color1B, escape = "|cffF6ADC6", "|cffADFF2F", "|r"
		elseif info == "dingMsg" and char.levelTimeList[player.level-1] then
			timeDiff = char.levelTimeList[player.level-1] - char.levelTimeList[player.level]
			color1A, color1B, escape = "", "", ""
		end
	end
	if timeDiff < 0 then
		return self:TimetoString(-timeDiff).." "..color1A..L["slower"]..escape -- make positive, if negative
	elseif timeDiff > 0 then
		return self:TimetoString(timeDiff).." "..color1B..L["faster"]..escape
	else
		return L["[No Data]"]
	end
end

--	update [AFK], [AFK+] DingMsgVar
local function TimeAFK()
	timeAFK2 = time()
	stats.timeAFK = stats.timeAFK + (timeAFK2-timeAFK1)
	stats.totalAFK = stats.totalAFK + (timeAFK2-timeAFK1)
end

function RSD:UpdateSummary()
	for i = 2, player.maxLevel do
		if char.levelTimeList[i] and char.levelCounter then
			char.levelSummary[char.levelCounter] = " "..LEVEL.." |cffF6ADC6"..(i-1).."|r - |cff71D5FF"..i.."|r:  |cffB6CA00"..self:TimetoString(char.levelTimeList[i], true).."|r        "..L["Total"]..":  |cff71D5FF"..self:TimetoString(char.totalTimeList[i], true).."|r\n"
			levelSummaryString = strjoin("", unpack(char.levelSummary))
		end
	end
end

local function ExpansionLimit(info)
	local nextLevel = player.level + 1
	if	   player.expansion == 3 and player.level < 85 then player.maxLevel = 85 -- Cataclysm
	elseif player.expansion == 2 and player.level < 80 then player.maxLevel = 80 -- Wrath of the Lich King
	elseif player.expansion == 1 and player.level < 70 then player.maxLevel = 70 -- The Burning Crusade
	elseif player.expansion == 0 and player.level < 60 then player.maxLevel = 60 -- Classic / Vanilla
	else nextLevel = "[Max Level]"
	end
	if info == "xNextLevel" then return nextLevel
	elseif info == "xPreviousLevel" then return player.level
	elseif info == "xRemainLevels" then return player.maxLevel - (player.level+1)
	elseif info == "remainLevels" then return player.maxLevel - player.level
	end
end

-- [SPEED] DingMsgVar; look for a 3 or smaller level difference
function RSD:RecentLevelSpeed()
	local a = char.levelTimeList
	for i = 3, 1, -1 do
		if a[player.level-i] then
			return ((a[player.level-i] + (TPM_totalTime-char.totalTimeList[player.level-i])) + self:AddedTime()) / (i+1)
		end
	end
	return a[player.level] and (a[player.level] + TPM_currentLevelTime + self:AddedTime()) or L["[No Data]"]
end

local function RandomAutoGratzMsg()
	return profile.autoGratzMsg[random(1, 6)]
end

local function RandomAutoGratzDelay()
	if profile.autoGratzDelay == 0 then
		return random(20, 70) / 10
	else
		return profile.autoGratzDelay
	end
end

local function GetClassColor(class)
	return format("%02X%02X%02X", RAID_CLASS_COLORS[class]["r"]*255, RAID_CLASS_COLORS[class]["g"]*255, RAID_CLASS_COLORS[class]["b"]*255)
end

function RSD:OutputFrame(msg, test)
	if profile.outputFrame == 1 then
		if test then msg = "UIErrorsFrame" end
		UIErrorsFrame:AddMessage(msg)
	elseif profile.outputFrame ==  2 then
		if test then msg = "RaidWarningFrame" end
		RaidNotice_AddMessage(RaidWarningFrame, msg, {r=1, g=1, b=1})
	elseif profile.outputFrame ==  3 then
		if test then msg = "RaidBossEmoteFrame" end
		RaidNotice_AddMessage(RaidBossEmoteFrame, msg, {r=1, g=1, b=1})
	else
		for i = 1, NUM_CHAT_WINDOWS do
			if test then msg = "RSD: |cff71D5FF"..i..". "..GetChatWindowInfo(i).."|r" end
			if i == profile.outputFrame-3 then
				_G["ChatFrame"..i]:AddMessage(msg)
			end
		end
	end
end

function RSD:InstanceAnnounce(subZone)
	SCM(self:ReplaceTextI(profile.instanceTimerMsg, "InstanceTimerMsg", subZone), GetNumPartyMembers() > 0 and "PARTY" or "SAY")
	self:RecordInstance(subZone)
end

-- Save Instance Timer data to array
function RSD:RecordInstance(subZone)
	local party = {}
	for i = 1, 4 do
		local a = UnitName("party"..i)
		if a then
			party[i] = a
		else
			party[i] = "*"
		end
	end

	if subZone then
		subZone = ": "..subZone.."]"
	else
		subZone = "]"
	end
	char.timeInstanceList[timeInstanceStart2.."-["..date("%H:%M").."]"] = "|cffADFF2F["..realZone..subZone.."|r in |cff71D5FF"..self:TimetoString(time() - timeInstance)..".|r "..party[1]..", "..party[2]..", "..party[3]..", "..party[4]
end

-- http://www.wowhead.com/achievements=2
function RSD:AchievementStatistics(info)
	local questsTotal, questsDaily, bgKills, arenaKills, totalDeaths

	if info == "QUESTS" then -- [QUESTS] DingMsgVar
		if GS(98) == "--" then questsTotal = 0 else questsTotal = tonumber(GS(98)) end -- 98 = Quests completed
		if GS(97) == "--" then questsDaily = 0 else questsDaily = tonumber(GS(97)) end -- 97 = Daily quests completed
	--	Quests Completed(Achievement) = Quests completed(Statistic) - Daily quests completed(Statistic); thank you aldon@wowhead
		return questsTotal - questsDaily
	elseif info == "KILLS" then -- [KILLS+] DingMsgVar
		if GS(1491) == "--" then bgKills = 0 else bgKills = tonumber(GS(1491)) end -- 1491 = Battleground Killing Blows GetStatistic(AchievementID) returns a string type, tonumber() makes it a number type
		if GS(1490) == "--" then arenaKills = 0 else arenaKills = tonumber(GS(1490)) end -- 1490 = Arena Killing Blows
		return bgKills + arenaKills + (stats.kills2 or 0)
	elseif info == "DEATHS" then -- [DEATHS+] DingMsgVar
		if GS(60) == "--" then totalDeaths = 0 else totalDeaths = tonumber(GS(60)) end -- 60 = Total Deaths
		return totalDeaths
	end
end

-- export level data to print/say (without spamming the server)
function RSD:ExportData(exportSay)
	local export
--	maybe I should learn how to sing the alphabet song ..
	local a, b, c, d, e -- delay
	local f, g, h, j -- coloring for print
	local k, l, m, n, o -- showed data type

--	why is there a throttle here anyway ... button bashers? spammers? xD
--	at least this will make sure LoggingChat() will be correctly set to it's previous value
	if not cd.export or time() > cd.export then
		cd.export = time() + 19

		if exportSay then
			a, b, c, d, e = 0, 4, 8, 12, 16
			f, g, h, j = "", "", "", ""
			export = SendChatMessage

			local isLogging = LoggingChat()
			LoggingChat(true)

			self:ScheduleTimer(function() LoggingChat(isLogging) end, 18)

		else
			a, b, c, d, e = 0, 0.5, 1, 1.5, 2
			f, g, h, j = "|cffF6ADC6", "|cff71D5FF", "|cffB6CA00", "|r"
			export = print
		end

		self:ScheduleTimer(function()
			for i = 2, player.maxLevel do
				if RSD.db.char.levelTimeList[i] then
					if not k then export("# "..L["Level Time"]); k = true end
					export(f..(i-1)..j.."-"..g..i..j..": "..h..RSD.db.char.levelTimeList[i]..j)
				end
			end
		end, a)
		self:ScheduleTimer(function()
			for i = 2, player.maxLevel do
				if RSD.db.char.totalTimeList[i] then
					if not l then export("# "..L["Total Time"]); l = true end
					export(g..i..j..": "..h..RSD.db.char.totalTimeList[i]..j)
				end
			end
		end, b)
		self:ScheduleTimer(function()
			for i = 2, player.maxLevel do
				local realTime, realTimeMinus = RSD.db.char.realTimeList[i], RSD.db.char.realTimeList[i-1]
				if realTime and realTimeMinus then
					if not m then export("# Real Time"); m = true end
					export(f..(i-1)..j.."-"..g..i..j..": "..h..realTime-realTimeMinus..j)
				end
			end
		end, c)
		self:ScheduleTimer(function()
			for i = 2, player.maxLevel do
				if RSD.db.char.dateStampList[i] then
					if not n then export("# "..L["Timestamp"]); n = true end
					export(g..i..j..": "..h..RSD.db.char.dateStampList[i]..j)
				end
			end
		end, d)
		self:ScheduleTimer(function()
			for i = 2, player.maxLevel do
				if RSD.db.char.realTimeList[i] then
					if not o then export("# Unix Timestamp"); o = true end
					export(g..i..j..": "..h..RSD.db.char.realTimeList[i]..j)
				end
			end
		end, e)
	end
end

function RSD:ValidateMessage(msg)
--	my patterns. just. suck. ><
	local msglen = gsub(RSD:ReplaceText(msg, "ExampleDingMsg"), "|r", "")
	msglen = gsub(msglen, "|cff......", "")
	msglen = gsub(msglen, "|T.-|t", "") -- this 1 completely removes the (raid target) texture ><

--	show an error if message length exceeds 127 or 255 chars
	local a = strlen(msglen)
	if a > 127 and RSD.db.profile.BNetBroadcast then
		print("RSD: |cff71D5FFReal ID|r |cffFF0000Message > 127 chars|r|r ("..a..")")
	end
	if a > 255 then
		print("RSD: |cffFF0000Message > 255 chars|r ("..a..")")
	end
end

function RSD:ReplaceText(msg, msgType)
--	** massive great wall of gsubs crits you for a ludicrous amount of antimatter dmg **
-- 	** your computer gets struck by a coronal loop .. unless you're happily reading this in the year 2014 .. **
	local gsub = gsub

	if msgType == "DingMsg" then
		msg = gsub(msg, "%[[Ll][Ee][Vv][Ee][Ll]%-%]", player.level-1)
		msg = gsub(msg, "%[[Ll][Ee][Vv][Ee][Ll]%]", player.level)
		msg = gsub(msg, "%[[Rr][Ee][Mm]%]", ExpansionLimit("remainLevels"))
		msg = gsub(msg, "%[[Mm][Aa][Xx]]", player.maxLevel)
		msg = gsub(msg, "%[[Tt][Ii][Mm][Ee]%]", self:TimetoString(levelTime2))
		msg = gsub(msg, "%[[Tt][Oo][Tt][Aa][Ll]%]", self:TimetoString(TPM_totalTime))
		msg = gsub(msg, "%[[Dd][Ii][Ff][Ff]%]", self:TimeDiff("dingMsg"))
		msg = gsub(msg, "%[[Aa][Ff][Kk]%]", self:TimetoString(stats.timeAFK))
		msg = gsub(msg, "%[[Aa][Ff][Kk]%+%]", self:TimetoString(stats.totalAFK))
		msg = gsub(msg, "%[[Dd][Aa][Tt][Ee]%]", date("%m/%d/%y %H:%M"))
		msg = gsub(msg, "%[[Dd][Aa][Tt][Ee]2%]", date("%Y.%m.%d %H:%M"))
		if self:RecentLevelSpeed() ~= L["[No Data]"] then
			msg = gsub(msg, "%[[Ss][Pp][Ee][Ee][Dd]%]", format("%.2f",self:RecentLevelSpeed()/3600))
		else
			msg = gsub(msg, "%[[Ss][Pp][Ee][Ee][Dd]%]", L["[No Data]"])
		end
		if player.level > 1 then
			msg = gsub(msg, "%[[Ss][Pp][Ee][Ee][Dd]%+%]", format("%.2f",(TPM_totalTime+self:AddedTime())/(3600*(player.level-1))))
		else
			msg = gsub(msg, "%[[Ss][Pp][Ee][Ee][Dd]%+%]", L["[No Data]"])
		end
		msg = gsub(msg, "%[[Kk][Ii][Ll][Ll][Ss]%]", stats.kills)
		msg = gsub(msg, "%[[Kk][Ii][Ll][Ll][Ss]%+%]", self:AchievementStatistics("KILLS"))
		msg = gsub(msg, "%[[Dd][Ee][Aa][Tt][Hh][Ss]%]", stats.deaths)
		msg = gsub(msg, "%[[Dd][Ee][Aa][Tt][Hh][Ss]%+%]", self:AchievementStatistics("DEATHS"))
		msg = gsub(msg, "%[[Qq][Uu][Ee][Ss][Tt][Ss]%]", self:AchievementStatistics("QUESTS"))
		msg = gsub(msg, "%[[Zz][Oo][Nn][Ee]%]", GetRealZoneText())
		msg = gsub(msg, "%[[Gg][Uu][Ii][Ll][Dd]%]", select(1, GetGuildInfo("player")) or "[No Guild]")
		msg = gsub(msg, "%[[Nn][Aa][Mm][Ee]%]", player.name)
		msg = gsub(msg, "%[[Cc][Ll][Aa][Ss][Ss]%]", player.class)
		msg = gsub(msg, "%[[Rr][Aa][Cc][Ee]%]", player.race)
		msg = gsub(msg, "%[[Ff][Aa][Cc][Tt][Ii][Oo][Nn]%]", player.faction)
		msg = gsub(msg, "%[[Rr][Ee][Aa][Ll][Mm]%]", player.realm)
		return msg

	elseif msgType == "ExampleDingMsg" then
		local RT = "Interface\\TargetingFrame\\UI-RaidTargetingIcon_"
		msg = gsub(msg, "%[[Ll][Ee][Vv][Ee][Ll]%-%]", "|cffF6ADC6"..ExpansionLimit("xPreviousLevel").."|r")
		msg = gsub(msg, "%[[Ll][Ee][Vv][Ee][Ll]%]", "|cffF6ADC6"..ExpansionLimit("xNextLevel").."|r")
		msg = gsub(msg, "%[[Rr][Ee][Mm]%]", "|cffF6ADC6"..ExpansionLimit("xRemainLevels").."|r")
		msg = gsub(msg, "%[[Mm][Aa][Xx]]", "|cffF6ADC6"..player.maxLevel.."|r")
		msg = gsub(msg, "%[[Tt][Ii][Mm][Ee]%]", "|cff71D5FF"..self:TimetoString(TPM_currentLevelTime+self:AddedTime()).."|r")
		msg = gsub(msg, "%[[Tt][Oo][Tt][Aa][Ll]%]", "|cff71D5FF"..self:TimetoString(TPM_totalTime+self:AddedTime()).."|r")
		msg = gsub(msg, "%[[Dd][Ii][Ff][Ff]%]", "|cff71D5FF"..self:TimeDiff("exampleMsg").."|r")
		msg = gsub(msg, "%[[Aa][Ff][Kk]%]", "|cff71D5FF"..self:TimetoString(stats.timeAFK).."|r")
		msg = gsub(msg, "%[[Aa][Ff][Kk]%+%]", "|cff71D5FF"..self:TimetoString(stats.totalAFK).."|r")
		msg = gsub(msg, "%[[Dd][Aa][Tt][Ee]%]", "|cff0070DD"..date("%m/%d/%y %H:%M").."|r")
		msg = gsub(msg, "%[[Dd][Aa][Tt][Ee]2%]", "|cff0070DD"..date("%Y.%m.%d %H:%M").."|r")
		if self:RecentLevelSpeed() ~= L["[No Data]"] then
			msg = gsub(msg, "%[[Ss][Pp][Ee][Ee][Dd]%]", "|cffB6CA00"..format("%.2f",self:RecentLevelSpeed()/3600).."|r")
		else
			msg = gsub(msg, "%[[Ss][Pp][Ee][Ee][Dd]%]", "|cffF6ADC6"..L["[No Data]"].."|r")
		end
		if player.level > 1 then
			msg = gsub(msg, "%[[Ss][Pp][Ee][Ee][Dd]%+%]", "|cffB6CA00"..format("%.2f",(TPM_totalTime+self:AddedTime())/(3600*(player.level-1))).."|r")
		else
			msg = gsub(msg, "%[[Ss][Pp][Ee][Ee][Dd]%+%]", "|cffF6ADC6"..L["[No Data]"].."|r")
		end
		msg = gsub(msg, "%[[Kk][Ii][Ll][Ll][Ss]%]", "|cffFF0000"..stats.kills.."|r")
		msg = gsub(msg, "%[[Kk][Ii][Ll][Ll][Ss]%+%]", "|cffFF0000"..self:AchievementStatistics("KILLS").."|r")
		msg = gsub(msg, "%[[Dd][Ee][Aa][Tt][Hh][Ss]%]", "|cffFF0000"..stats.deaths.."|r")
		msg = gsub(msg, "%[[Dd][Ee][Aa][Tt][Hh][Ss]%+%]", "|cffFF0000"..self:AchievementStatistics("DEATHS").."|r")
		msg = gsub(msg, "%[[Qq][Uu][Ee][Ss][Tt][Ss]%]", "|cff58ACFA"..self:AchievementStatistics("QUESTS").."|r")
		if GetRealZoneText() then
			msg = gsub(msg, "%[[Zz][Oo][Nn][Ee]%]", "|cff58ACFA"..GetRealZoneText().."|r") -- not sure if its too early or already avaiable at this point
		else
			msg = gsub(msg, "%[[Zz][Oo][Nn][Ee]%]", "|cffF6ADC6[No Zone Info]|r")
		end
		if IsInGuild() and GetGuildInfo("player") then
			msg = gsub(msg, "%[[Gg][Uu][Ii][Ll][Dd]%]", "|cffADFF2F"..GetGuildInfo("player").."|r")
		else
			msg = gsub(msg, "%[[Gg][Uu][Ii][Ll][Dd]%]", "|cffF6ADC6[No Guild]|r")
		end
		msg = gsub(msg, "%[[Nn][Aa][Mm][Ee]%]", "|cffADFF2F"..player.name.."|r")
		msg = gsub(msg, "%[[Cc][Ll][Aa][Ss][Ss]%]", "|cffADFF2F"..player.class.."|r")
		msg = gsub(msg, "%[[Rr][Aa][Cc][Ee]%]", "|cffADFF2F"..player.race.."|r")
		msg = gsub(msg, "%[[Ff][Aa][Cc][Tt][Ii][Oo][Nn]%]", "|cffADFF2F"..player.faction.."|r")
		msg = gsub(msg, "%[[Rr][Ee][Aa][Ll][Mm]%]", "|cffADFF2F"..player.realm.."|r")
		for i = 1, 8 do
			msg = gsub(msg, "%{[Rr][Tt]"..i.."%}", "|T"..RT..i..":12|t")
		end
		msg = gsub(msg, "%{[Xx]%}", "|T"..RT.."7:12|t")
		msg = gsub(msg, "%{[Ss][Tt][Aa][Rr]%}", "|T"..RT.."1:12|t")
		msg = gsub(msg, "%{[Cc][Ii][Rr][Cc][Ll][Ee]%}", "|T"..RT.."2:12|t")
		msg = gsub(msg, "%{[Dd][Ii][Aa][Mm][Oo][Nn][Dd]%}", "|T"..RT.."3:12|t")
		msg = gsub(msg, "%{[Tt][Rr][Ii][Aa][Nn][Gg][Ll][Ee]%}", "|T"..RT.."4:12|t")
		msg = gsub(msg, "%{[Mm][Oo][Oo][Nn]%}", "|T"..RT.."5:12|t")
		msg = gsub(msg, "%{[Ss][Qq][Uu][Aa][Rr][Ee]%}", "|T"..RT.."6:12|t")
		msg = gsub(msg, "%{[Cc][Rr][Oo][Ss][Ss]%}", "|T"..RT.."7:12|t")
		msg = gsub(msg, "%{[Ss][Kk][Uu][Ll][Ll]%}", "|T"..RT.."8:12|t")
		return msg
	elseif msgType == "AutoGratzMsg" then -- capitalized name would be a bit "suspicious"
		msg = gsub(msg, "%[[Nn][Aa][Mm][Ee]%]", strlower(gratzName))
		return msg
	end
end

function RSD:ReplaceTextI(msg, msgType, extraInfo)
	local gsub = gsub	

	if msgType == "xInstanceTimerMsg" then
		local a = select(2, IsInInstance())
		msg = gsub(msg, "%[[Ii][Nn][Ss][Tt][Aa][Nn][Cc][Ee]%]", a == "party" and "|cffA8A8FF"..GetRealZoneText().."|r" or "|cffA8A8FFDeadmines|r")
		msg = gsub(msg, "%[[Tt][Ii][Mm][Ee]%]", a == "party" and "|cff71D5FF"..(self:TimetoString(time() - timeInstance)).."|r" or "|cff71D5FF"..self:TimetoString(1500).."|r")
		msg = gsub(msg, "%[[Ss][Tt][Aa][Rr][Tt]%]", a == "party" and "|cffF6ADC6"..(timeInstanceStart or 0).."|r" or "|cffF6ADC614:27|r")
		msg = gsub(msg, "%[[Ee][Nn][Dd]%]", a == "party" and "|cffADFF2F"..date("%H:%M").."|r" or "|cffADFF2F14:52|r")
		return msg

	elseif msgType == "InstanceTimerMsg" then
		if extraInfo then
			msg = gsub(msg, "%[[Ii][Nn][Ss][Tt][Aa][Nn][Cc][Ee]%]", GetRealZoneText()..": "..extraInfo)
		else
			msg = gsub(msg, "%[[Ii][Nn][Ss][Tt][Aa][Nn][Cc][Ee]%]", GetRealZoneText())
		end
		msg = gsub(msg, "%[[Tt][Ii][Mm][Ee]%]", self:TimetoString(time() - timeInstance))
		msg = gsub(msg, "%[[Ss][Tt][Aa][Rr][Tt]%]", timeInstanceStart)
		msg = gsub(msg, "%[[Ee][Nn][Dd]%]", timeInstanceEnd)
		return msg
	end
end

function RSD:ReplaceTextG(msg, msgType, name, level, class, rank, zone, time, levelSpeed, classColor)
	local gsub = gsub

	if msgType == "GUILDMEMBERMSG" then
		msg = gsub(msg, "%[[Nn][Aa][Mm][Ee]%]", name)
		msg = gsub(msg, "%[[Ll][Ee][Vv][Ee][Ll]%-%]", level-1)
		msg = gsub(msg, "%[[Ll][Ee][Vv][Ee][Ll]%]", level)
		msg = gsub(msg, "%[[Cc][Ll][Aa][Ss][Ss]%]", class)
		msg = gsub(msg, "%[[Rr][Aa][Nn][Kk]%]", rank)
		msg = gsub(msg, "%[[Zz][Oo][Nn][Ee]%]", zone or "")
		msg = gsub(msg, "%[[Tt][Ii][Mm][Ee]%]", time)
		msg = gsub(msg, "%[[Ss][Pp][Ee][Ee][Dd]%]", levelSpeed)
		return msg

	elseif msgType == "xGUILDMEMBERMSG" then
		msg = gsub(msg, "%[[Nn][Aa][Mm][Ee]%]", "|cff"..GetClassColor(classColor).."|Hplayer:"..name.."|h"..name.."|h|r")
		msg = gsub(msg, "%[[Ll][Ee][Vv][Ee][Ll]%-%]", "|cffF6ADC6"..(level-1).."|r")
		msg = gsub(msg, "%[[Ll][Ee][Vv][Ee][Ll]%]", "|cffADFF2F"..level.."|r")
		msg = gsub(msg, "%[[Cc][Ll][Aa][Ss][Ss]%]", "|cff71D5FF"..class.."|r")
		msg = gsub(msg, "%[[Rr][Aa][Nn][Kk]%]", "|cffADFF2F"..rank.."|r")
		if zone then -- guild member's zone sometimes is nil
			msg = gsub(msg, "%[[Zz][Oo][Nn][Ee]%]", "|cffF6ADC6"..zone.."|r")
		else
			msg = gsub(msg, "%[[Zz][Oo][Nn][Ee]%]", "")
		end
		msg = gsub(msg, "%[[Tt][Ii][Mm][Ee]%]", "|cff71D5FF"..time.."|r")
		msg = gsub(msg, "%[[Ss][Pp][Ee][Ee][Dd]%]", "|cffB6CA00"..levelSpeed.."|r")
		return msg
	end
end

	-----------------------------
	--- 05  OnEvent Functions ---
	-----------------------------

function RSD:PLAYER_LEVEL_UP(_, level)
	player.level = level
	playerDinged = true
	RequestTimePlayed() -- call TIME_PLAYED_MSG (event)

	if not char.levelCounter or char.levelCounter > 18 then
		char.levelCounter = 0 -- reset if leveled 19+ times
	end
	char.levelCounter = char.levelCounter + 1
end

function RSD:TIME_PLAYED_MSG(_, ...)
--	these variables must be file-local scope, instead of function-local scope; using vararg (...)
	TPM_totalTime, TPM_currentLevelTime = ...
	lastPlayedRequest = time()

	if not playerDinged then
		TPM_totalTime2 = TPM_totalTime
		TPM_currentLevelTime2 = TPM_currentLevelTime -- used to "guess" levelTime
	elseif playerDinged and TPM_currentLevelTime <= 7 then -- 7 seconds grace period wherein the AddOn "assumes" the player has recently dinged
		playerDinged = false

	--	A: Last undinged LevelTime + (dinged TotalTime - last undinged TotalTime) cant be used for in DingMsg examples, since it wont get refreshed (only when /played fires) time() as in "addedTime" is used for that
		levelTime = TPM_currentLevelTime2 + (TPM_totalTime - TPM_totalTime2)
		TPM_totalTime2 = TPM_totalTime TPM_currentLevelTime2 = TPM_currentLevelTime -- update time variables for next level

	--	B: TotalTime @ Ding - TotalTime @ previous Ding (more accurate)
		if char.totalTimeList[player.level-1] then
			levelTime2 = TPM_totalTime - char.totalTimeList[player.level-1]
		else
			levelTime2 = levelTime -- fall back to method A if no data for previous level
		end

	--	save player data to arrays
		char.levelTimeList[player.level] = levelTime2
		char.totalTimeList[player.level] = TPM_totalTime
		char.realTimeList[player.level] = time()
		char.dateStampList[player.level] = date("%Y.%m.%d %H:%M:%S")

	--	update level summary
		self:UpdateSummary()
		
	--	play custom sound if the user supplied one, otherwise it will silently fail
		PlaySoundFile(profile.customSound, "Master")

		local msgType, randomMsg
		if profile.randomMessage then
			randomMsg = random(2, 6)
		else
			randomMsg = 1
		end

		instanceType = select(2, IsInInstance())
	--	Announce Ding Message
		if profile.normalAnnounce then
		--	announce to /say instead when soloing instance
			if instanceType == "none" or instanceType == "party" then
				msgType = GetNumPartyMembers() > 0 and "PARTY" or "SAY"
			elseif instanceType == "raid" then
				msgType = "RAID"
			elseif instanceType == "pvp" then
				msgType = "BATTLEGROUND"
			end
			
			self:ScheduleTimer(function() SCM(self:ReplaceText(profile.dingMessage[randomMsg], "DingMsg"), msgType) end, profile.announceDelay)
		else
			self:OutputFrame(self:ReplaceText(profile.dingMessage[randomMsg], "DingMsg"))
		end

	--	Zone Announce
		if profile.zoneAnnounce then
			local a = {GetChannelList()}
			for i = 1, 10 do
			--	General channel can have any channel number assigned 
				if a[i*2] == GENERAL then
					self:ScheduleTimer(function() SCM(self:ReplaceText(profile.dingMessage[randomMsg], "DingMsg"), "CHANNEL", nil, i*2-1) end, profile.announceDelay)
				end
			end
		end

	--	Guild Announce
		if profile.guildAnnounce and IsInGuild() then
			self:ScheduleTimer(function() SCM(self:ReplaceText(profile.dingMessage[randomMsg], "DingMsg"), "GUILD") end, profile.announceDelay)
		end
		
	--	Real ID Broadcast
		if profile.BNetBroadcast then
		--	save current Real ID Broadcast message
			local broadcastMsg = select(3, BNGetInfo())
			self:ScheduleTimer(function()
				BNSetCustomMessage(self:ReplaceText(profile.dingMessage[randomMsg], "DingMsg"))
				BNSetCustomMessage(broadcastMsg)
			end, profile.announceDelay)
		end

	--	Screenshot
		if profile.Screenshot then
		--	Hide UI (+ optional delay) to show the LevelUp animation
			local timeHideUI = profile.screenshotDelay-1
			if timeHideUI < 0 then timeHideUI = 0 end -- change any negative value to zero
		--	get original alpha for some reason its always a bit different than the set value e.g. 0.9 -> 0.988... 0.5 -> 0.498...
			local originalAlpha = UIParent:GetAlpha()
		--	got problems with timing hiding and showing UI again,
		--	so trying to Hide()/SetAlpha(0) 1sec before screenshot
			if profile.screenshotHideUI then
				self:ScheduleTimer(function() UIParent:SetAlpha(0) end, timeHideUI)
			end
			self:ScheduleTimer(function() Screenshot() end, profile.screenshotDelay)
			if profile.screenshotHideUI then
				self:ScheduleTimer(function() UIParent:SetAlpha(originalAlpha) end, profile.screenshotDelay+1)
			end
		end

	--	reset [KILLS], [DEATHS], [AFK] DingMessageVar
		stats.kills, stats.deaths, stats.timeAFK = 0, 0, 0
	end
	self:NotifyChange()
end

function RSD:GUILD_ROSTER_UPDATE()
	for i = 1, GetNumGuildMembers() do
		local name, rank, _, level, class, zone, _, _, _, _, classFileName = GetGuildRosterInfo(i)
		local classColor = GetClassColor(classFileName)

	--	sanity check: in rare cases GetGuildRosterInfo() returns only a nil
		if name then
			if profile.GuildMemberDings then
				if realm[name] then
				
				--	save (last 3 levels) level speed to [0] key
					for j = 3, 1, -1 do
					--	ignore the [0] and [1] key values
						if realm[name][level-j] and level-j ~= 1 and level-j ~= 0 then
							realm[name][0] = (time()-realm[name][level-j][1]) / (3600*j)
							break
						end
					end

				--	level changed
					if level > realm[name][1] and name ~= player.name then
					--	online check (1 minute grace period for updating/logging in)
						if time() > timeLogin + 60 then
							local a, b = "", ""
						
						--	level time
							if realm[name][level-1] and realm[name][level-1][1] then
								a = " in "..self:TimetoString(time() - realm[name][level-1][1])
							end

						--	level speed
							if realm[name][0] then
								b = " ("..format("%.2f", 1/realm[name][0]).." "..Hour.."/"..LEVEL..")"
							end

						--	level filters
							if level >= profile.guildMemberLevelFilter and (not guildMemberAchievementFilter or (guildMemberAchievementFilter and (level < 10 or strsub(level, 2, 2) ~= "0") and level ~= 85)) then
								if profile.guildMemberAnnounce then
									SendChatMessage(self:ReplaceTextG(profile.guildMemberMsg, "GUILDMEMBERMSG", name, level, class, rank, zone, a, b), "GUILD")
								else
									self:OutputFrame(self:ReplaceTextG(profile.guildMemberMsg, "xGUILDMEMBERMSG", name, level, class, rank, zone, a, b, classFileName))
								end
							end
						--	save time & date of levelup
							realm[name][level] = {}
							realm[name][level][1] = time()
							realm[name][level][2] = date("%Y.%m.%d %H:%M:%S")
						else
						--	level changed while user was offline
							realm[name][level] = false -- don't got time & date
							if not showedDiffs and char.lastCheck then
								showedDiffs = true
								print("RSD: |cffF6ADC6["..char.lastCheck.."]|r - |cffADFF2F["..date("%Y.%m.%d %H:%M").."]|r")
							end
							print("RSD: |cff"..classColor.."|Hplayer:"..name.."|h["..name.."]|h|r "..LEVEL.." |cffF6ADC6"..realm[name][1].."|r - |cffADFF2F"..level.."|r (+|cff71D5FF"..level-realm[name][1].."|r)")
						end
					end
				end
			end
		--	define guildmember / update level to [1] key
			realm[name] = realm[name] or {}
			realm[name][1] = level
		end
	end
end

function RSD:COMBAT_LOG_EVENT_UNFILTERED(...)
	local _, _, event, _, sourceName, _, destGUID, destName, _, _, spellName, _, _, SuffixParam2 = ...
	local Time = time()
	local destType = strsub(destGUID, 5, 5)

--	refresh instanceType and realZone
	if Time > (cd.zone or 0) then
		cd.zone = Time + 10
		realZone = GetRealZoneText()
		instanceType = select(2, IsInInstance())
	end

--	[Deaths] DingMsgVar
	if event == "UNIT_DIED" and destName == player.name then
		stats.deaths = stats.deaths + 1
	end

--	[KILLS], [KILLS+] DingMsgVar
	if sourceName == player.name and destType == "0" then
		if ((event == "SPELL_DAMAGE" or event == "SPELL_PERIODIC_DAMAGE" or event == "RANGE_DAMAGE") and SuffixParam2 > 0) or (event == "SWING_DAMAGE" and spellName > 0) and Time > (cd.PlayerKill or 0) then
			cd.PlayerKill = Time + 0.5
			stats.kills = stats.kills + 1
			if instanceType ~= "pvp" and instanceType ~= "arena" then
				stats.kills2 = stats.kills2 + 1
			end
		end
	end

--# Instance Timer
--	LFG_COMPLETION_REWARD (event) would be a suitable alternative, but it only works when queued for random dungeons
	if event == "UNIT_DIED" and profile.instanceTimer and instanceType == "party" and (timeInstance > 0 or timeInstance2 > 0) then
		local destNPC = tonumber(strsub(destGUID, 7, 10), 16)
		for _, v in pairs(BossIDs) do
			if v == destNPC then
				timeInstanceEnd = date("%H:%M")
			--	"Scarlet Monastery"
				if destNPC == 4543 then self:InstanceAnnounce("Graveyard") -- [27-37?] Bloodmage Thalnos
				elseif destNPC == 6487 then self:InstanceAnnounce("Library") -- [30-40?] Arcanist Doan
				elseif destNPC == 3975 then self:InstanceAnnounce("Armory") -- [32-42?] Herod
				elseif destNPC == 3977 then self:InstanceAnnounce("Cathedral") -- [35-45] High Inquisitor Whitemane
			--	"Maraudon"
				elseif destNPC == 12236 then self:InstanceAnnounce("The Wicked Grotto"); timeInstance2 = timeInstance -- [39-49?] Lord Vyletongue
				elseif destNPC == 12258 then self:InstanceAnnounce("Foulspore Cavern"); timeInstance2 = timeInstance -- [41-51?] Razorlash
				elseif destNPC == 12201 then
					if timeInstance2 > 0 then timeInstance = timeInstance2 end
					self:InstanceAnnounce("Earth Song Falls") -- [34-44] Princess Theradras
			--	"Blackrock Depths"
				elseif destNPC == 9018 then self:InstanceAnnounce("Detention Block"); timeInstance2 = timeInstance -- [47-57] High Interrogator Gerstahn
				elseif destNPC == 9019 then
					if timeInstance2 > 0 then timeInstance = timeInstance2 end
					self:InstanceAnnounce("Upper City") -- [51-61] Emperor Dagran Thaurissan
			--	"Dire Maul"
				elseif destNPC == 11492 then self:InstanceAnnounce("Warpwood Quarter") -- [36-46] Alzzin the Wildshaper
				elseif destNPC == 11486 then self:InstanceAnnounce("Capital Gardens") -- [39-49] Prince Tortheldrin
				elseif destNPC == 11501 then self:InstanceAnnounce("Gordok Commons") -- [42-52] King Gordok
			--	"Stratholme"
				elseif destNPC == 10813 then self:InstanceAnnounce("Main Gate"); timeInstance2 = timeInstance -- [42-52] Balnazzar
				elseif destNPC == 45412 then
					if timeInstance2 > 0 then timeInstance = timeInstance2 end
					self:InstanceAnnounce("Service Entrance") -- [46-56] Lord Aurius Rivendare
				else
					self:InstanceAnnounce()
				end
				-- reset "timers"
				timeInstance, timeInstance2 = 0, 0
				timeInstanceStart, timeInstanceStart2, timeInstanceEnd = "", "", ""
				break
			end
		end
	end
end

function RSD:CHAT_MSG_CHANNEL_NOTICE(_, msg)
	if msg == "YOU_CHANGED" then
	--	reset timer if it's 2 hours since last time player entered instance
		if select(2, IsInInstance()) == "party" and (timeInstance == 0 or time() > timeInstance + 7200) then
			timeInstance, timeInstanceStart, timeInstanceStart2 = time(), date("%H:%M"), date("%Y.%m.%d [%H:%M]")
		end
	end
end

function RSD:LFG_PROPOSAL_SUCCEEDED()
	self:ScheduleTimer(function()
	--	backup timer (30 sec) for if timeInstance still is nil
		if timeInstance == 0 then
			timeInstance, timeInstanceStart, timeInstanceStart2 = time(), date("%H:%M"), date("%Y.%m.%d [%H:%M]")
		end
	end, 30)
end

-- Instance Timer for "special" boss deaths (not localized)
function RSD:CHAT_MSG_MONSTER_YELL(_, msg)
	if profile.instanceTimer and instanceType == "party" and timeInstance > 0 then
		if msg == "No! I can do... better! I can..." or -- "Utgarde Keep" (Boss dies twice)
		msg == "Your journey has just begun, young prince. Gather your forces and meet me in the arctic land of Northrend. It is there that we shall settle the score between us. It is there that your true destiny will unfold." or -- "The Culling of Stratholme" (no death)
		msg == "No! I must not fail... again..." or -- "Trial of the Champion" (Boss dies x3)
		msg == "FIRE! FIRE!" then -- "Halls of Reflection" (invinceable; Escape Event)
			timeInstanceEnd = date("%H:%M")
			self:InstanceAnnounce()
		--	reset variables
			timeInstance, timeInstanceStart, timeInstanceStart2, timeInstanceEnd = 0, "", "", ""
		end
	end
end

--# Auto Gratz events
--	dont alt+tab with auto gratz on, it will spam all "queued" dings once you alt+tab back in
--	rather than checking for different names, just a global cooldown/throttle, since I suspect it would be abused fairly much
function RSD:CHAT_MSG_PARTY(_, msg, unit)
	if profile.AutoGratz and unit ~= player.name and strfind(msg, "[Dd][Ii][Nn][Gg]") and strlen(msg) <= 10 and time() > (cd.autoGratzParty or 0) then
		gratzName = unit
		cd.autoGratzParty = time() + profile.autoGratzCooldown
		self:ScheduleTimer(function() SCM(self:ReplaceText(RandomAutoGratzMsg(), "AutoGratzMsg"), "PARTY") end, RandomAutoGratzDelay())
	end
end

function RSD:CHAT_MSG_GUILD(_, msg, unit)
	if profile.AutoGratz and unit ~= player.name and strfind(msg, "[Dd][Ii][Nn][Gg]") and strlen(msg) <= 10 and time() > (cd.autoGratzGuild or 0) then
		gratzName = unit
		cd.autoGratzGuild = time() + profile.autoGratzCooldown
		self:ScheduleTimer(function() SCM(self:ReplaceText(RandomAutoGratzMsg(), "AutoGratzMsg"), "GUILD") end, RandomAutoGratzDelay())
	end
end

function RSD:CHAT_MSG_GUILD_ACHIEVEMENT(_, msg, unit)
	if profile.AutoGratz and ((not profile.gratzAllAchievements and strfind(msg, LEVEL)) or profile.gratzAllAchievements) and unit ~= player.name and time() > (cd.autoGratzGuild or 0) then
		gratzName = unit
		cd.autoGratzGuild = time() + profile.autoGratzCooldown
		self:ScheduleTimer(function() SCM(self:ReplaceText(RandomAutoGratzMsg(), "AutoGratzMsg"), "GUILD") end, RandomAutoGratzDelay())
	end
end

function RSD:CHAT_MSG_SYSTEM(_, msg)
	if strfind(msg, MARKED_AFK) or strfind(msg, MARKED_AFK_MESSAGE) then
		timeAFK1 = time()
	end
	if msg == CLEARED_AFK and timeAFK1 then
		TimeAFK()
	end
--	reset Instance Timer if left or kicked from group
	if msg == ERR_LEFT_GROUP_YOU or msg == ERR_UNINVITE_YOU then
		timeInstance = 0
	end
end

function RSD:PLAYER_LEAVING_WORLD() -- update [AFK], [AFK+] DingMsgVar
	if UnitIsAFK("player") and timeAFK1 then
		TimeAFK()
	end
--	time/date at logout for showing levelDiffs..
	char.lastCheck = date("%Y.%m.%d %H:%M")
end